/******************************************************************************
*                                                                             *
*    Ant-RP.cpp                             Copyright(c) 2007-2010 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#define INITGUID

#include <windows.h>
#include <commctrl.h>
#include <shlobj.h>
#include <shlwapi.h>
#include <tchar.h>

#include "pntypes.h"
#include "pnwintyp.h"
#include "pncom.h"
#include "rmapckts.h"
#include "rmacomm.h"
#include "rmamon.h"
#include "rmafiles.h"
#include "rmaengin.h"
#include "rmacore.h"
#include "rmaclsnk.h"
#include "rmaerror.h"
#include "rmaauth.h"
#include "rmaausvc.h"
#include "rmawin.h"

#include "Ant-RP.h"
#include "ClientAdviseSink.h"
#include "ErrorSink.h"
#include "SiteSupplier.h"
#include "AuthenticManager.h"
#include "ClientContext.h"
#include "DropTarget.h"
#include "Settings.h"
#include "resource.h"


#define ANT_SETTINGS_INI	// ݒINIt@Cɕۑ

#define MAIN_WINDOW_CLASS	TEXT("Ant-RP Main Form")
#define SCREEN_WINDOW_CLASS	TEXT("Ant-RP Screen")
#define TITLE_TEXT TEXT("Ant-RP")

#define IDC_SCREEN	300
#define IDC_TOOLBAR	301
#define IDC_STATUS	302

// Tuj[̈ʒu
#define MENU_VOLUME	4
#define MENU_ZOOM	5

#define VOLUME_STEP 5


static HINSTANCE hInst;
#ifdef ANT_SETTINGS_INI
static TCHAR szIniFileName[MAX_PATH];
#endif
static HWND hwndMain;
static HWND hwndScreen;
static HWND hwndToolbar;
static HIMAGELIST himlToolbarNormal=NULL;
static HIMAGELIST himlToolbarDisabled=NULL;
static HWND hwndStatus;
static bool fShowToolbar=true;
static int WindowLeft=CW_USEDEFAULT;
static int WindowTop=CW_USEDEFAULT;
static int WindowWidth=400;
static int WindowHeight=320;
static bool fMaximize=false;
static bool fAlwaysOnTop=false;
static bool fFileOpen=false;
static bool fLoading=false;
static LPTSTR pszCurrentFileName=NULL;
static TCHAR szFileOpenDirectory[MAX_PATH];
static int OpenFilterIndex=1;
static bool fFirstOpen;
static HICON hicoLogo=NULL;
enum StatusType {
	STATUS_TIME,
	STATUS_TITLE,
	STATUS_AUTHOR,
	STATUS_COPYRIGHT
};
static StatusType CurrentStatusType=STATUS_TIME;
#define NUM_STATUS_TYPES 4
static unsigned int CurrentLength;
static int OriginalWidth;
static int OriginalHeight;
static int LastVolume=100;

static AntClientContext *pContext=NULL;
static IRMAPlayer *pPlayer=NULL;
static IRMAClientEngine *pEngine=NULL;
static IRMAErrorSink *pErrorSink=NULL;
static IRMAErrorSinkControl *pErrorSinkControl=NULL;
static AntDropTarget *pDropTarget=NULL;




HINSTANCE GetResourceInstance()
{
	return hInst;
}


HWND GetMainWindow()
{
	return hwndMain;
}


HWND GetScreenWindow()
{
	return hwndScreen;
}


/*
	ԂtH[}bg
*/
#define FORMATTIME_DECIMAL	0x0001
#define FORMATTIME_TIME		0x0002

static LPTSTR FormatTime(LPTSTR pszText,UINT uMilliSeconds,unsigned int Flags)
{
	TCHAR szTmp[16];

	if ((Flags&FORMATTIME_TIME)!=0)
		wsprintf(pszText,TEXT("%02d:"),uMilliSeconds/3600000);
	else
		pszText[0]='\0';
	wsprintf(szTmp,TEXT("%02d:"),uMilliSeconds/60000%60);
	lstrcat(pszText,szTmp);
	wsprintf(szTmp,TEXT("%02d"),uMilliSeconds/1000%60);
	lstrcat(pszText,szTmp);
	if ((Flags&FORMATTIME_DECIMAL)!=0) {
		TCHAR szDecimal[4];

		GetLocaleInfo(LOCALE_USER_DEFAULT,LOCALE_SDECIMAL,szDecimal,
														lengthof(szDecimal));
		wsprintf(szTmp,TEXT("%s%02d"),szDecimal,uMilliSeconds/10%100);
		lstrcat(pszText,szTmp);
	}
	return pszText;
}


static bool LoadSettings()
{
	int Value;
#ifdef ANT_SETTINGS_INI
	AntIniSettings Settings;
	if (!Settings.Open(szIniFileName,TEXT("Settings"),AntSettings::OPEN_READ))
		return false;
#else
	AntRegSettings Settings;
	if (!Settings.Open(HKEY_CURRENT_USER,TEXT("Software\\itowy\\Ant-RP"),
													AntSettings::OPEN_READ))
		return false;
#endif
	Settings.ReadInt(TEXT("WindowLeft"),&WindowLeft);
	Settings.ReadInt(TEXT("WindowTop"),&WindowTop);
	Settings.ReadInt(TEXT("WindowWidth"),&WindowWidth);
	Settings.ReadInt(TEXT("WindowHeight"),&WindowHeight);
	if (Settings.ReadInt(TEXT("Maximize"),&Value))
		fMaximize=Value!=0;
	if (Settings.ReadInt(TEXT("AlwaysOnTop"),&Value))
		fAlwaysOnTop=Value!=0;
	Settings.ReadString(TEXT("OpenDirectory"),szFileOpenDirectory,
												lengthof(szFileOpenDirectory));
	Settings.ReadInt(TEXT("OpenFilter"),&OpenFilterIndex);
	if (Settings.ReadInt(TEXT("LastVolume"),&LastVolume)) {
		if (LastVolume<0)
			LastVolume=0;
		else if (LastVolume>100)
			LastVolume=100;
	}
	Settings.Close();
	return true;
}


static bool SaveSettings()
{
#ifdef ANT_SETTINGS_INI
	AntIniSettings Settings;
	if (!Settings.Open(szIniFileName,TEXT("Settings"),AntSettings::OPEN_WRITE))
		return false;
#else
	AntRegSettings Settings;
	if (!Settings.Open(HKEY_CURRENT_USER,TEXT("Software\\itowy\\Ant-RP"),
													AntSettings::OPEN_WRITE))
		return false;
#endif
	if (WindowLeft!=CW_USEDEFAULT)
		Settings.WriteInt(TEXT("WindowLeft"),WindowLeft);
	if (WindowTop!=CW_USEDEFAULT)
		Settings.WriteInt(TEXT("WindowTop"),WindowTop);
	Settings.WriteInt(TEXT("WindowWidth"),WindowWidth);
	Settings.WriteInt(TEXT("WindowHeight"),WindowHeight);
	Settings.WriteInt(TEXT("Maximize"),fMaximize);
	Settings.WriteInt(TEXT("AlwaysOnTop"),fAlwaysOnTop);
	Settings.WriteString(TEXT("OpenDirectory"),szFileOpenDirectory);
	Settings.WriteInt(TEXT("OpenFilter"),OpenFilterIndex);
	Settings.WriteInt(TEXT("LastVolume"),LastVolume);
	Settings.Close();
	return true;
}


static bool IsLocalFile(LPCTSTR pszFileName)
{
	return (IsCharAlpha(pszFileName[0]) && pszFileName[1]==':')
							|| (pszFileName[0]=='\\' && pszFileName[1]=='\\');
}


static void SetStatusText(LPCTSTR pszText)
{
	SetWindowText(hwndStatus,pszText);
}


#ifndef UNICODE
#define SetStatusTextA SetStatusText
#else
static void SetStatusTextA(LPCSTR pszText)
{
	SetWindowTextA(hwndStatus,pszText);
}
#endif


static void SetStatusTimeText(unsigned int Pos)
{
	TCHAR szText[64],szPos[32],szLength[32];
	unsigned int Flags;

	Flags=0;
	if (CurrentLength<10000)
		Flags|=FORMATTIME_DECIMAL;
	if (CurrentLength>=3600000)
		Flags|=FORMATTIME_TIME;
	wsprintf(szText,TEXT("%s / %s"),FormatTime(szPos,Pos,Flags),
									FormatTime(szLength,CurrentLength,Flags));
	SetStatusText(szText);
}


static bool SetStatusTypeText(StatusType Type)
{
	switch (Type) {
	case STATUS_TIME:
		SetStatusTimeText(pPlayer->IsDone()?CurrentLength:
												pPlayer->GetCurrentPlayTime());
		break;
	case STATUS_TITLE:
	case STATUS_AUTHOR:
	case STATUS_COPYRIGHT:
		{
			AntTACManager *pTACManager=
							pContext->GetClientAdviseSink()->GetTACManager();
			const char *pText;

			switch (Type) {
			case STATUS_TITLE:
				pText=pTACManager->GetTitle();
				break;
			case STATUS_AUTHOR:
				pText=pTACManager->GetAuthor();
				break;
			case STATUS_COPYRIGHT:
				pText=pTACManager->GetCopyright();
				break;
			}
			if (pText==NULL || pText[0]=='\0')
				return false;
			SetStatusTextA(pText);
		}
		break;
	}
	return true;
}


static void ChangeStatusType()
{
	int i;
	StatusType Type;

	for (i=1;i<NUM_STATUS_TYPES;i++) {
		Type=(StatusType)((CurrentStatusType+i)%NUM_STATUS_TYPES);
		if (SetStatusTypeText(Type))
			break;
	}
	CurrentStatusType=Type;
}


static HWND CreateToolbar(HWND hwndParent)
{
	static const TBBUTTON tbb[] = {
		{0,	CM_OPEN,	TBSTATE_ENABLED,	BTNS_BUTTON,		{0,0},	0,0},
		{0,	0,			TBSTATE_ENABLED,	BTNS_SEP,			{0,0},	0,0},
		{1,	CM_PLAY,	0,					BTNS_CHECKGROUP,	{0,0},	0,0},
		{2,	CM_PAUSE,	0,					BTNS_CHECKGROUP,	{0,0},	0,0},
		{3,	CM_STOP,	0,					BTNS_CHECKGROUP,	{0,0},	0,0},
		{0,	0,			TBSTATE_ENABLED,	BTNS_SEP,			{0,0},	0,0},
	};
	HWND hwnd;
	RECT rc;
	HFONT hfont;
	LOGFONT lf;

	hwnd=CreateWindowEx(0,TOOLBARCLASSNAME,NULL,
			WS_CHILD | (fShowToolbar?WS_VISIBLE:0) | WS_CLIPCHILDREN |
				CCS_BOTTOM | CCS_NODIVIDER | TBSTYLE_TOOLTIPS | TBSTYLE_FLAT,
			0,0,0,0,hwndParent,(HMENU)IDC_TOOLBAR,hInst,NULL);
	if (hwnd==NULL)
		return NULL;
	SendMessage(hwnd,TB_BUTTONSTRUCTSIZE,sizeof(TBBUTTON),0);
	SendMessage(hwnd,TB_SETBITMAPSIZE,0,MAKELONG(16,16));
	if (himlToolbarNormal==NULL)
		himlToolbarNormal=ImageList_LoadImage(hInst,
			MAKEINTRESOURCE(IDB_TOOLBAR),16,1,RGB(192,192,192),
											IMAGE_BITMAP,LR_CREATEDIBSECTION);
	SendMessage(hwnd,TB_SETIMAGELIST,0,(LPARAM)himlToolbarNormal);
	if (himlToolbarDisabled==NULL)
		himlToolbarDisabled=ImageList_LoadImage(hInst,
			MAKEINTRESOURCE(IDB_TOOLBAR_DISABLE),16,1,RGB(192,192,192),
											IMAGE_BITMAP,LR_CREATEDIBSECTION);
	SendMessage(hwnd,TB_SETDISABLEDIMAGELIST,0,(LPARAM)himlToolbarDisabled);
	SendMessage(hwnd,TB_ADDBUTTONS,lengthof(tbb),(LPARAM)&tbb);
	hwndStatus=CreateWindow(TEXT("STATIC"),TEXT(""),
		WS_CHILD | WS_VISIBLE | SS_LEFTNOWORDWRAP | SS_NOTIFY | SS_OWNERDRAW,
									0,0,0,0,hwnd,(HMENU)IDC_STATUS,hInst,NULL);
	hfont=(HFONT)GetStockObject(DEFAULT_GUI_FONT);
	SendMessage(hwndStatus,WM_SETFONT,(WPARAM)hfont,FALSE);
	SendMessage(hwnd,TB_GETITEMRECT,lengthof(tbb)-1,(LPARAM)&rc);
	GetObject(hfont,sizeof(LOGFONT),&lf);
	MoveWindow(hwndStatus,rc.right,
							rc.top+((rc.bottom-rc.top)-abs(lf.lfHeight))/2-2,
												0,abs(lf.lfHeight)+4,FALSE);
	return hwnd;
}


static void DisableControlButtons()
{
	static const int Commands[] = {CM_PLAY,CM_PAUSE,CM_STOP};
	int i;

	for (i=0;i<lengthof(Commands);i++) {
		SendMessage(hwndToolbar,TB_ENABLEBUTTON,Commands[i],FALSE);
		SendMessage(hwndToolbar,TB_CHECKBUTTON,Commands[i],FALSE);
	}
}


static LPTSTR GetFileNamePtr(LPCTSTR pszPath)
{
	LPCTSTR pszFileName,p;

	p=pszFileName=pszPath;
	while (*p!='\0') {
		if (*p=='\\' || *p=='/')
			pszFileName=++p;
#ifndef UNICODE
		else if (IsDBCSLeadByteEx(CP_ACP,*p))
			p+=2;
#endif
		else
			p++;
	}
	return const_cast<LPTSTR>(pszFileName);
}


static void SetTitleText()
{
	if (fFileOpen) {
		LPCTSTR pszFileName=GetFileNamePtr(pszCurrentFileName);
		int Length;
		LPTSTR pszTitle;

		Length=lstrlen(pszFileName)+3+lengthof(TITLE_TEXT);
		pszTitle=new TCHAR[Length];
		wsprintf(pszTitle,TEXT("%s - ") TITLE_TEXT,pszFileName);
		SetWindowText(hwndMain,pszTitle);
		delete [] pszTitle;
	} else {
		SetWindowText(hwndMain,TITLE_TEXT);
	}
}


static void AdjustWindowSize()
{
	HWND hwnd;
	RECT rc,rcWindow,rcWorkArea;
	int MinWidth=220;
	int Width,Height;

	hwnd=pContext->GetWindow();
	if (hwnd!=NULL) {
		GetWindowRect(hwnd,&rc);
		Width=rc.right-rc.left;
		Height=rc.bottom-rc.top;
		if (Width<MinWidth)
			Width=MinWidth;
	} else {
		Width=MinWidth;
		Height=0;
	}
	rc.left=0;
	rc.top=0;
	rc.right=Width+GetSystemMetrics(SM_CXEDGE)*2;
	rc.bottom=Height+GetSystemMetrics(SM_CYEDGE)*2;
	AdjustWindowRectEx(&rc,GetWindowLong(hwndMain,GWL_STYLE),FALSE,
										GetWindowLong(hwndMain,GWL_EXSTYLE));
	if (fShowToolbar) {
		RECT rcToolbar;

		GetWindowRect(hwndToolbar,&rcToolbar);
		rc.bottom+=rcToolbar.bottom-rcToolbar.top;
	}
	GetWindowRect(hwndMain,&rcWindow);
	OffsetRect(&rc,rcWindow.left-rc.left,rcWindow.top-rc.top);
	// fXNgbv͈̔͂擾
	HMONITOR hMonitor=MonitorFromWindow(hwndMain,MONITOR_DEFAULTTONEAREST);
	MONITORINFO mi;
	if (GetMonitorInfo(hMonitor,&mi)) {
		rcWorkArea=mi.rcWork;
	} else {
		if (!SystemParametersInfo(SPI_GETWORKAREA,0,&rcWorkArea,0)) {
			rcWorkArea.left=rcWorkArea.top=0;
			rcWorkArea.right=GetSystemMetrics(SM_CXSCREEN);
			rcWorkArea.bottom=GetSystemMetrics(SM_CYSCREEN);
		}
	}
	// EBhEʓɎ܂悤ɂ
	if (rc.right>rcWorkArea.right) {
		rc.left-=rc.right-rcWorkArea.right;
		rc.right=rcWorkArea.right;
		if (rc.left<rcWorkArea.left) {
			rc.right+=rcWorkArea.left-rc.left;
			rc.left=rcWorkArea.left;
			if (rc.right>rcWorkArea.right)
				rc.right=rcWorkArea.right;
		}
	}
	if (rc.bottom>rcWorkArea.bottom) {
		rc.top-=rc.bottom-rcWorkArea.bottom;
		rc.bottom=rcWorkArea.bottom;
		if (rc.top<rcWorkArea.top) {
			rc.bottom+=rcWorkArea.top-rc.top;
			rc.top=rcWorkArea.top;
			if (rc.bottom>rcWorkArea.bottom)
				rc.bottom=rcWorkArea.bottom;
		}
	}
	MoveWindow(hwndMain,rc.left,rc.top,rc.right-rc.left,rc.bottom-rc.top,TRUE);
}


static bool OpenMediaFile(LPCTSTR pszFileName)
{
	bool fLocal=IsLocalFile(pszFileName);
	LPTSTR pszBuff=NULL;
	LPCTSTR pszURL;

	if (fLocal) {
		pszBuff=new TCHAR[lstrlen(pszFileName)+6];
		wsprintf(pszBuff,TEXT("file:%s"),pszFileName);
		pszURL=pszBuff;
	} else
		pszURL=pszFileName;
	fLoading=true;
	DisableControlButtons();
	if (pPlayer->OpenURL(pszURL)!=PNR_OK) {
		delete [] pszBuff;
		fLoading=false;
		return false;
	}
	delete [] pszBuff;
	fFileOpen=true;
	fFirstOpen=true;
	delete [] pszCurrentFileName;
	pszCurrentFileName=new TCHAR[lstrlen(pszFileName)+1];
	lstrcpy(pszCurrentFileName,pszFileName);
	if (fLocal) {
		lstrcpy(szFileOpenDirectory,pszFileName);
		PathRemoveFileSpec(szFileOpenDirectory);
	}
	SetTitleText();
	pPlayer->Begin();
	return true;
}


/*
	o[W_CAOvV[W
*/
static INT_PTR CALLBACK AboutDlgProc(HWND hDlg,UINT uMsg,
												WPARAM wParam,LPARAM lParam)
{
	static HFONT hfontLink;

	switch (uMsg) {
	case WM_INITDIALOG:
		{
			LOGFONT lf;

			GetObject((HFONT)SendMessage(hDlg,WM_GETFONT,0,0),
														sizeof(LOGFONT),&lf);
			lf.lfUnderline=1;
			hfontLink=CreateFontIndirect(&lf);
			SendDlgItemMessage(hDlg,IDC_ABOUT_WEB,WM_SETFONT,
													(WPARAM)hfontLink,FALSE);
		}
		return TRUE;

	case WM_CTLCOLORSTATIC:
		if ((HWND)lParam==GetDlgItem(hDlg,IDC_ABOUT_WEB)) {
			SetTextColor((HDC)wParam,RGB(0,0,255));
			SetBkMode((HDC)wParam,TRANSPARENT);
			return (BOOL)(HBRUSH)GetStockObject(NULL_BRUSH);
		}
		break;

	case WM_SETCURSOR:
		if ((HWND)wParam==GetDlgItem(hDlg,IDC_ABOUT_WEB)) {
			SetCursor(LoadCursor(NULL,IDC_HAND));
			SetWindowLongPtr(hDlg,DWLP_MSGRESULT,TRUE);
			return TRUE;
		}
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_ABOUT_WEB:
			if (HIWORD(wParam)==STN_CLICKED)
				ShellExecute(NULL,TEXT("open"),
							TEXT("http://www.geocities.jp/iooiau/"),NULL,NULL,
																SW_SHOWNORMAL);
			return TRUE;
		case IDOK:
		case IDCANCEL:
			EndDialog(hDlg,LOWORD(wParam));
			return TRUE;
		}
		return TRUE;

	case WM_DESTROY:
		DeleteObject(hfontLink);
		return TRUE;
	}
	return FALSE;
}


static void CopyMenuStatus(HMENU hmenu,int Command)
{
	UINT State=SendMessage(hwndToolbar,TB_GETSTATE,Command,0);

	if ((State&TBSTATE_ENABLED)==0)
		EnableMenuItem(hmenu,Command,MF_BYCOMMAND | MFS_GRAYED);
	if ((State&TBSTATE_CHECKED)!=0)
		CheckMenuItem(hmenu,Command,MF_BYCOMMAND | MFS_CHECKED);
}


static LRESULT CALLBACK ScreenWndProc(HWND hwnd,UINT uMsg,
												WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_CREATE:
		return 0;

	case WM_PAINT:
		if (!fFileOpen && hicoLogo!=NULL) {
			PAINTSTRUCT ps;
			RECT rc;

			BeginPaint(hwnd,&ps);
			GetClientRect(hwnd,&rc);
			DrawIcon(ps.hdc,(rc.right-32)/2,(rc.bottom-32)/2,hicoLogo);
			EndPaint(hwnd,&ps);
			return 0;
		}
		break;

	case WM_SIZE:
		if (pContext!=NULL) {
			HWND hwndMedia=pContext->GetWindow();

			if (hwndMedia!=NULL) {
				int Width=LOWORD(lParam),Height=HIWORD(lParam);
				int cx,cy;

				cx=min((OriginalWidth*Height)/OriginalHeight,Width);
				cy=min((OriginalHeight*Width)/OriginalWidth,Height);
				MoveWindow(hwndMedia,(Width-cx)/2,(Height-cy)/2,cx,cy,TRUE);
			}
		}
		return 0;

	case WM_RBUTTONDOWN:
		{
			POINT pt;
			HMENU hmenu;

			//pt.x=LOWORD(lParam);
			//pt.y=HIWORD(lParam);
			//ClientToScreen(hwnd,&pt);
			GetCursorPos(&pt);
			if (fFileOpen) {
				hmenu=LoadMenu(hInst,MAKEINTRESOURCE(IDM_PLAY));
				CopyMenuStatus(hmenu,CM_PLAY);
				CopyMenuStatus(hmenu,CM_PAUSE);
				CopyMenuStatus(hmenu,CM_STOP);
				EnableMenuItem(hmenu,MENU_ZOOM,MF_BYPOSITION |
						(pContext->GetWindow()!=NULL?MFS_ENABLED:MFS_GRAYED));
			} else
				hmenu=LoadMenu(hInst,MAKEINTRESOURCE(IDM_MAIN));
			if (fAlwaysOnTop)
				CheckMenuItem(hmenu,CM_ALWAYSONTOP,MF_BYCOMMAND | MFS_CHECKED);
			TrackPopupMenu(GetSubMenu(hmenu,0),TPM_RIGHTBUTTON,pt.x,pt.y,0,
																hwndMain,NULL);
			DestroyMenu(hmenu);
		}
		return 0;
	}
	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}


static LRESULT CALLBACK MainWndProc(HWND hwnd,UINT uMsg,
												WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_CREATE:
		hwndScreen=CreateWindowEx(WS_EX_CLIENTEDGE,SCREEN_WINDOW_CLASS,NULL,
									WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN,
									0,0,0,0,hwnd,(HMENU)IDC_SCREEN,hInst,NULL);
		if (hwndScreen==NULL)
			return -1;
		hwndToolbar=CreateToolbar(hwnd);
		pDropTarget=new AntDropTarget;
		RegisterDragDrop(hwnd,pDropTarget);
		return 0;

	case WM_SIZE:
		{
			int Width=LOWORD(lParam),Height=HIWORD(lParam);

			if (fShowToolbar) {
				RECT rc,rcStatus;

				SendMessage(hwndToolbar,TB_AUTOSIZE,0,0);
				GetWindowRect(hwndToolbar,&rc);
				Height-=rc.bottom-rc.top;
				GetWindowRect(hwndStatus,&rcStatus);
				MapWindowPoints(NULL,hwndToolbar,(POINT*)&rcStatus,2);
				MoveWindow(hwndStatus,rcStatus.left,rcStatus.top,
					max(Width-rcStatus.left,0),rcStatus.bottom-rcStatus.top,
																		FALSE);
				InvalidateRect(hwndStatus,NULL,TRUE);
			}
			MoveWindow(hwndScreen,0,0,Width,Height,TRUE);
		}
		return 0;

	case WM_DROPFILES:
		{
			HDROP hdrop=(HDROP)wParam;
			TCHAR szFileName[MAX_PATH];

			SetForegroundWindow(hwnd);
			DragQueryFile(hdrop,0,szFileName,lengthof(szFileName));
			OpenMediaFile(szFileName);
			DragFinish(hdrop);
		}
		return 0;

	case WM_SETCURSOR:
		if ((HWND)wParam==hwndStatus) {
			SetCursor(LoadCursor(NULL,IDC_HAND));
			return TRUE;
		}
		break;

	case WM_DRAWITEM:
		if (wParam==IDC_STATUS) {
			LPDRAWITEMSTRUCT pdis=(LPDRAWITEMSTRUCT)lParam;
			TCHAR szText[MAX_PATH+64];
			COLORREF crOldTextColor;
			int OldBkMode;
			RECT rc;

			GetWindowText(hwndStatus,szText,lengthof(szText));
			rc=pdis->rcItem;
			DrawEdge(pdis->hDC,&rc,BDR_SUNKENOUTER,BF_RECT | BF_ADJUST);
			FillRect(pdis->hDC,&rc,(HBRUSH)GetStockObject(BLACK_BRUSH));
			crOldTextColor=SetTextColor(pdis->hDC,RGB(224,224,224));
			OldBkMode=SetBkMode(pdis->hDC,TRANSPARENT);
			rc.left++;
			rc.right--;
			DrawText(pdis->hDC,szText,-1,&rc,
				DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX | DT_END_ELLIPSIS);
			SetTextColor(pdis->hDC,crOldTextColor);
			SetBkMode(pdis->hDC,OldBkMode);
			return TRUE;
		}
		break;

	case WM_NOTIFY:
		switch (((LPNMHDR)lParam)->code) {
		case TTN_NEEDTEXT:
			{
				LPTOOLTIPTEXT pttt=(LPTOOLTIPTEXT)lParam;

				pttt->lpszText=(LPTSTR)pttt->hdr.idFrom;
				pttt->hinst=hInst;
			}
			return 0;
		}
		break;

	case ANT_MESSAGE_OPEN:
		return OpenMediaFile((LPCTSTR)lParam);

	case ANT_MESSAGE_NOTIFY:
		switch (wParam) {
		case NOTIFY_OPEN:
			fLoading=false;
			{
				HWND hwndMedia=pContext->GetWindow();

				if (hwndMedia!=NULL) {
					RECT rc;

					GetWindowRect(hwndMedia,&rc);
					OriginalWidth=rc.right-rc.left;
					OriginalHeight=rc.bottom-rc.top;
				}
			}
			if (fFirstOpen) {
				AdjustWindowSize();
				fFirstOpen=false;
			}
			{
				RECT rc;
				GetClientRect(hwndScreen,&rc);
				SendMessage(hwndScreen,WM_SIZE,0,
											MAKELPARAM(rc.right,rc.bottom));
			}
			SendMessage(hwndToolbar,TB_ENABLEBUTTON,CM_PLAY,TRUE);
			SendMessage(hwndToolbar,TB_ENABLEBUTTON,CM_PAUSE,TRUE);
			SendMessage(hwndToolbar,TB_ENABLEBUTTON,CM_STOP,TRUE);
			break;
		case NOTIFY_CLOSE:
			break;
		case NOTIFY_PLAY:
			fLoading=false;
			if (CurrentStatusType!=STATUS_TIME) {
				if (!SetStatusTypeText(CurrentStatusType))
					CurrentStatusType=STATUS_TIME;
			}
			SendMessage(hwndToolbar,TB_CHECKBUTTON,CM_PLAY,TRUE);
			SendMessage(hwndToolbar,TB_ENABLEBUTTON,CM_PAUSE,TRUE);
			SendMessage(hwndToolbar,TB_CHECKBUTTON,CM_PAUSE,FALSE);
			SendMessage(hwndToolbar,TB_CHECKBUTTON,CM_STOP,FALSE);
			break;
		case NOTIFY_PAUSE:
			if (CurrentStatusType==STATUS_TIME)
				SetStatusTypeText(STATUS_TIME);
			SendMessage(hwndToolbar,TB_CHECKBUTTON,CM_PLAY,FALSE);
			SendMessage(hwndToolbar,TB_CHECKBUTTON,CM_PAUSE,TRUE);
			SendMessage(hwndToolbar,TB_CHECKBUTTON,CM_STOP,FALSE);
			break;
		case NOTIFY_STOP:
			SendMessage(hwndToolbar,TB_CHECKBUTTON,CM_PLAY,FALSE);
			SendMessage(hwndToolbar,TB_ENABLEBUTTON,CM_PAUSE,FALSE);
			SendMessage(hwndToolbar,TB_CHECKBUTTON,CM_PAUSE,FALSE);
			SendMessage(hwndToolbar,TB_CHECKBUTTON,CM_STOP,TRUE);
			break;
		}
		return 0;

	case ANT_MESSAGE_POSLENGTH:
		CurrentLength=lParam;
		if (CurrentStatusType==STATUS_TIME)
			SetStatusTimeText(wParam);
		return 0;

	case ANT_MESSAGE_BUFFERING:
		if (fLoading) {
			TCHAR szText[64];

			LoadString(hInst,IDS_BUFFERING,szText,lengthof(szText));
			wsprintf(szText+lstrlen(szText),TEXT(" : %d%%"),lParam);
			SetStatusText(szText);
		}
		return 0;

	case ANT_MESSAGE_CONTACTING:
		{
			TCHAR szText[MAX_PATH+64];

			LoadString(hInst,IDS_CONTACTING,szText,lengthof(szText));
			wsprintf(szText+lstrlen(szText),TEXT(" : %s"),(LPCTSTR)lParam);
			SetStatusText(szText);
		}
		return 0;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case CM_OPEN:
			{
				OPENFILENAME ofn;
				TCHAR szFilter[256],*p;
				TCHAR szFileName[MAX_PATH];

				LoadString(hInst,IDS_FILTER,szFilter,lengthof(szFilter));
				p=szFilter;
				while (*p!='\0') {
#ifndef UNICODE
					if (IsDBCSLeadByteEx(CP_ACP,*p) && *(p+1)!='\0')
						p++;
					else
#endif
					if (*p=='|')
						*p='\0';
					p++;
				}
				szFileName[0]='\0';
#if _WIN32_WINNT>=0x0500
				ofn.lStructSize=OPENFILENAME_SIZE_VERSION_400;
#else
				ofn.lStructSize=sizeof(OPENFILENAME);
#endif
				ofn.hwndOwner=hwnd;
				ofn.lpstrFilter=szFilter;
				ofn.lpstrCustomFilter=NULL;
				ofn.nFilterIndex=OpenFilterIndex;
				ofn.lpstrFile=szFileName;
				ofn.nMaxFile=lengthof(szFileName);
				ofn.lpstrFileTitle=NULL;
				ofn.lpstrInitialDir=szFileOpenDirectory;
				ofn.lpstrTitle=NULL;
				ofn.Flags=OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
				ofn.lpstrDefExt=NULL;
				if (GetOpenFileName(&ofn)) {
					OpenFilterIndex=ofn.nFilterIndex;
					OpenMediaFile(szFileName);
				}
			}
			return 0;

		case CM_ALWAYSONTOP:
			fAlwaysOnTop=!fAlwaysOnTop;
			SetWindowPos(hwnd,fAlwaysOnTop?HWND_TOPMOST:HWND_NOTOPMOST,
											0,0,0,0,SWP_NOMOVE | SWP_NOSIZE);
			return 0;

		case CM_ABOUT:
			DialogBox(hInst,MAKEINTRESOURCE(IDD_ABOUT),hwnd,AboutDlgProc);
			return 0;

		case CM_EXIT:
			SendMessage(hwnd,WM_CLOSE,0,0);
			return 0;

		case CM_PLAY:
			if (pPlayer->IsDone()) {
				LPTSTR pszBuff=NULL;
				LPCTSTR pszURL;

				if (IsLocalFile(pszCurrentFileName)) {
					pszBuff=new TCHAR[lstrlen(pszCurrentFileName)+6];
					wsprintf(pszBuff,TEXT("file:%s"),pszCurrentFileName);
					pszURL=pszBuff;
				} else
					pszURL=pszCurrentFileName;
				fLoading=true;
				DisableControlButtons();
				if (pPlayer->OpenURL(pszURL)!=PNR_OK) {
					delete [] pszBuff;
					fLoading=false;
					return 0;
				}
				delete [] pszBuff;
			}
			pPlayer->Begin();
			return 0;

		case CM_PAUSE:
			pPlayer->Pause();
			return 0;

		case CM_STOP:
			pPlayer->Stop();
			pPlayer->Seek(0);
			if (CurrentStatusType==STATUS_TIME)
				SetStatusTypeText(STATUS_TIME);
			return 0;

		case CM_VOLUME_UP:
		case CM_VOLUME_DOWN:
		case CM_MUTE:
			{
				IRMAAudioPlayer *pAudioPlayer;

				if (SUCCEEDED(pPlayer->QueryInterface(IID_IRMAAudioPlayer,
													(void**)&pAudioPlayer))) {
					IRMAVolume *pVolume=pAudioPlayer->GetAudioVolume();
					if (pVolume!=NULL) {
						if (LOWORD(wParam)==CM_MUTE) {
							pVolume->SetMute(!pVolume->GetMute());
						} else {
							UINT16 Volume=pVolume->GetVolume();

							if (LOWORD(wParam)==CM_VOLUME_UP) {
								Volume=(UINT16)
											min((long)Volume+VOLUME_STEP,100);
							} else {
								Volume=(UINT16)max((long)Volume-VOLUME_STEP,0);
							}
							pVolume->SetVolume(Volume);
							if (pVolume->GetMute())
								pVolume->SetMute(FALSE);
							LastVolume=Volume;
						}
						pVolume->Release();
					}
					pAudioPlayer->Release();
				}
			}
			return 0;

		case CM_ZOOM50:
		case CM_ZOOM75:
		case CM_ZOOM100:
		case CM_ZOOM150:
		case CM_ZOOM200:
			{
				HWND hwndMedia=pContext->GetWindow();

				if (hwndMedia!=NULL) {
					static const int ZoomList[] = {50,75,100,150,200};
					int i=LOWORD(wParam)-CM_ZOOM_FIRST;
					int Width,Height;
					RECT rc;

					Width=max(OriginalWidth*ZoomList[i]/100,1);
					Height=max(OriginalHeight*ZoomList[i]/100,1);
					GetClientRect(hwndScreen,&rc);
					MoveWindow(hwndMedia,(rc.right-Width)/2,(rc.bottom-Height)/2,
															Width,Height,TRUE);
					AdjustWindowSize();
				}
			}
			return 0;

		case IDC_STATUS:
			if (fFileOpen && !fLoading && HIWORD(wParam)==STN_CLICKED)
				ChangeStatusType();
			return 0;
		}
		return 0;

	case WM_DESTROY:
		{
			WINDOWPLACEMENT wp;

			wp.length=sizeof(WINDOWPLACEMENT);
			if (GetWindowPlacement(hwndMain,&wp)) {
				// GetWindowPlacement Ŏ擾̂̓[NXy[XW
				if (wp.showCmd==SW_SHOWNORMAL) {
					GetWindowRect(hwnd,&wp.rcNormalPosition);
				} else {
					HMONITOR hMonitor=
							MonitorFromWindow(hwnd,MONITOR_DEFAULTTOPRIMARY);
					MONITORINFO mi;

					mi.cbSize=sizeof(mi);
					if (GetMonitorInfo(hMonitor,&mi))
						OffsetRect(&wp.rcNormalPosition,
											-mi.rcWork.left,-mi.rcWork.top);
				}
				WindowLeft=wp.rcNormalPosition.left;
				WindowTop=wp.rcNormalPosition.top;
				WindowWidth=wp.rcNormalPosition.right-wp.rcNormalPosition.left;
				WindowHeight=wp.rcNormalPosition.bottom-wp.rcNormalPosition.top;
				fMaximize=wp.showCmd==SW_SHOWMAXIMIZED;
			}
			RevokeDragDrop(hwnd);
			pDropTarget->Release();
			delete [] pszCurrentFileName;
			if (himlToolbarNormal!=NULL)
				ImageList_Destroy(himlToolbarNormal);
			if (himlToolbarDisabled!=NULL)
				ImageList_Destroy(himlToolbarDisabled);
			PostQuitMessage(0);
		}
		return 0;
	}
	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}


int APIENTRY _tWinMain(HINSTANCE hInstance,HINSTANCE /*hPrevInstance*/,
												LPTSTR pszCmdLine,int nCmdShow)
{
	FPRMCREATEENGINE pCreateEngine;
	FPRMCLOSEENGINE pCloseEngine;
	HACCEL hAccel;
	TCHAR szDLLFileName[MAX_PATH];
	HMODULE hDLL;

	/*
		ϐ̏
	*/
	hInst=hInstance;
#ifdef ANT_SETTINGS_INI
	GetModuleFileName(NULL,szIniFileName,lengthof(szIniFileName));
	PathRenameExtension(szIniFileName,TEXT(".ini"));
#endif

	LoadSettings();
	if (szFileOpenDirectory[0]=='\0') {
		ITEMIDLIST *pid;

		if (SHGetSpecialFolderLocation(NULL,CSIDL_PERSONAL,&pid)==NOERROR) {
			SHGetPathFromIDList(pid,szFileOpenDirectory);
			CoTaskMemFree(pid);
		}
	}

	/*
		EBhENX̓o^
	*/
	{
		WNDCLASS wc;

		wc.style=0;
		wc.lpfnWndProc=MainWndProc;
		wc.cbClsExtra=0;
		wc.cbWndExtra=0;
		wc.hInstance=hInst;
		wc.hIcon=LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON));
		wc.hCursor=LoadCursor(NULL,IDC_ARROW);
		wc.hbrBackground=(HBRUSH)(COLOR_3DFACE+1);
		wc.lpszMenuName=NULL;
		wc.lpszClassName=MAIN_WINDOW_CLASS;
		if (RegisterClass(&wc)==0) {
			MessageBox(NULL,TEXT("Failed to register class."),NULL,
														MB_OK | MB_ICONSTOP);
			return FALSE;
		}
		wc.style=CS_HREDRAW | CS_VREDRAW;
		wc.lpfnWndProc=ScreenWndProc;
		wc.cbClsExtra=0;
		wc.cbWndExtra=0;
		wc.hInstance=hInst;
		wc.hIcon=NULL;
		wc.hCursor=LoadCursor(NULL,IDC_ARROW);
		wc.hbrBackground=CreateSolidBrush(RGB(0,0,0));
		wc.lpszMenuName=NULL;
		wc.lpszClassName=SCREEN_WINDOW_CLASS;
		if (RegisterClass(&wc)==0) {
			MessageBox(NULL,TEXT("Failed to register class."),NULL,
														MB_OK | MB_ICONSTOP);
			return FALSE;
		}
	}

	/*
		RRg[̏
	*/
#if _WIN32_IE<0x0300
	InitCommonControls();
#else
	{
		INITCOMMONCONTROLSEX icc;

		icc.dwSize=sizeof(INITCOMMONCONTROLSEX);
		icc.dwICC=ICC_BAR_CLASSES;
		InitCommonControlsEx(&icc);
	}
#endif

	/*
		OLE ̏
	*/
	OleInitialize(NULL);

	/*
		CEBhE̍쐬
	*/
	hwndMain=CreateWindowEx(
		WS_EX_ACCEPTFILES | (fAlwaysOnTop?WS_EX_TOPMOST:0),
		MAIN_WINDOW_CLASS,TITLE_TEXT,
		WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | (fMaximize?WS_MAXIMIZE:0),
		WindowLeft,WindowTop,WindowWidth,WindowHeight,NULL,NULL,hInst,NULL);
	if (hwndMain==NULL) {
		MessageBox(NULL,TEXT("Can't create window."),NULL,MB_OK | MB_ICONSTOP);
		return FALSE;
	}
	ShowWindow(hwndMain,nCmdShow);
	UpdateWindow(hwndMain);

	/*
		ANZ[^̓ǂݍ
	*/
	hAccel=LoadAccelerators(hInst,MAKEINTRESOURCE(IDA_ACCEL));
	if (hAccel==NULL){
		MessageBox(hwndMain,TEXT("Failed to load accelerators."),NULL,
														MB_OK | MB_ICONSTOP);
		DestroyWindow(hwndMain);
		return FALSE;
	}

	/*
		Cu̓ǂݍ
	*/
	{
		HKEY hkey; 

		szDLLFileName[0]='\0';
		if (RegOpenKeyEx(HKEY_CLASSES_ROOT,
					TEXT("Software\\RealNetworks\\Preferences\\DT_Common"),0,
									KEY_QUERY_VALUE,&hkey)==ERROR_SUCCESS) {
			DWORD Size;

			Size=sizeof(szDLLFileName);
			RegQueryValueEx(hkey,TEXT(""),NULL,NULL,(LPBYTE)szDLLFileName,&Size);
			RegCloseKey(hkey);
		}
		PathAppend(szDLLFileName,TEXT("pnen3260.dll"));
	}
	hDLL=(HMODULE)LoadLibrary(szDLLFileName);
	if (hDLL==NULL) {
		MessageBox(hwndMain,TEXT("Failed to load \"pnen3260.dll\"."),NULL,
														MB_OK | MB_ICONSTOP);
		goto CleanUp;
	}
	pCreateEngine=(FPRMCREATEENGINE)GetProcAddress(hDLL,"CreateEngine");
	pCloseEngine=(FPRMCLOSEENGINE)GetProcAddress(hDLL,"CloseEngine");
	if (pCreateEngine==NULL || pCloseEngine==NULL) {
		MessageBox(hwndMain,TEXT("Failed to get proc address."),NULL,
														MB_OK | MB_ICONSTOP);
		goto CleanUp;
	}

	pContext=new AntClientContext;
	if ((*pCreateEngine)((IRMAClientEngine**)&pEngine)!=PNR_OK) {
		MessageBox(hwndMain,TEXT("Failed to create engine."),NULL,
														MB_OK | MB_ICONSTOP);
		goto CleanUp;
	}
	if (pEngine->CreatePlayer(pPlayer)!=PNR_OK) {
		MessageBox(hwndMain,TEXT("Failed to create player."),NULL,
														MB_OK | MB_ICONSTOP);
		goto CleanUp;
	}
	pContext->Init(pPlayer);
	pPlayer->SetClientContext(pContext);
	pPlayer->QueryInterface(IID_IRMAErrorSinkControl,
												(void**)&pErrorSinkControl);
	if (pErrorSinkControl!=NULL) {
		pContext->QueryInterface(IID_IRMAErrorSink,(void**)&pErrorSink);
		pErrorSinkControl->AddErrorSink(pErrorSink,PNLOG_EMERG,PNLOG_INFO);
	}
	if (LastVolume!=100) {
		IRMAAudioPlayer *pAudioPlayer;
		if (SUCCEEDED(pPlayer->QueryInterface(IID_IRMAAudioPlayer,
													(void**)&pAudioPlayer))) {
			IRMAVolume *pVolume=pAudioPlayer->GetAudioVolume();
			if (pVolume!=NULL) {
				pVolume->SetVolume(LastVolume);
				pVolume->Release();
			}
			pAudioPlayer->Release();
		}
	}

	/*
		IiKŃS\
	*/
	hicoLogo=LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON));
	InvalidateRect(hwndScreen,NULL,FALSE);
	UpdateWindow(hwndScreen);

	/*
		R}hC̃t@CJ
	*/
	if (pszCmdLine[0]!='\0') {
		TCHAR szFileName[MAX_PATH],*q;
		LPCTSTR p;
		TCHAR Delimiter;
		int i;

		p=pszCmdLine;
		q=szFileName;
		if (*p=='\"') {
			Delimiter='"';
			p++;
		} else
			Delimiter=' ';
		for (i=0;i<lengthof(szFileName) && *p!=Delimiter && *p!='\0';i++) {
#ifndef UNICODE
			if (IsDBCSLeadByteEx(CP_ACP,*p)) {
				i++;
				if (i==lengthof(szFileName))
					break;
				*q++=*p++;
			}
#endif
			*q++=*p++;
		}
		if (i<lengthof(szFileName)) {
			*q='\0';
			if (IsLocalFile(szFileName))
				GetLongPathName(szFileName,szFileName,lengthof(szFileName));
			OpenMediaFile(szFileName);
		} else
			MessageBox(hwndMain,TEXT("File path too large."),NULL,
												MB_OK | MB_ICONEXCLAMATION);
	}

	/*
		bZ[W[v
	*/
	MSG msg;
	BOOL Result;
	while ((Result=GetMessage(&msg,NULL,0,0))!=0) {
		if (Result==-1) {
			MessageBox(NULL,TEXT("GetMessage()"),NULL,MB_OK | MB_ICONSTOP);
			break;
		}
		if (!TranslateAccelerator(hwndMain,hAccel,&msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	SaveSettings();

CleanUp:
	if (pErrorSinkControl!=NULL) {
		pErrorSinkControl->RemoveErrorSink(pErrorSink);
		pErrorSinkControl->Release();
	}
	if (pContext!=NULL)
		pContext->Release();
	if (pPlayer!=NULL) {
		pEngine->ClosePlayer(pPlayer);
		pPlayer->Release();
	}
	if (pEngine!=NULL)
		(*pCloseEngine)(pEngine);
	if (hDLL!=NULL)
		FreeLibrary(hDLL);

	OleUninitialize();

	return msg.wParam;
}
