/******************************************************************************
*                                                                             *
*    Map.cpp                                Copyright(c) 2007-1010 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <string.h>
#include "Map.h"


#define ALLOC_SIZE 10




AntMap::AntMap()
	: m_pArray(NULL)
	, m_MapSize(0)
	, m_AllocSize(0)
	, m_Cursor(0)
{
}


AntMap::~AntMap()
{
	delete [] m_pArray;
}


void *AntMap::GetFirstValue()
{
	m_Cursor=0;
	if (m_MapSize>0)
		return m_pArray[m_Cursor].pValue;
	return NULL;
}


void *AntMap::GetNextValue()
{
	m_Cursor++;
	if (m_Cursor<m_MapSize)
		return m_pArray[m_Cursor].pValue;
	return NULL;
}


bool AntMap::Lookup(void *Key, void*& Value) const
{
	int i;

	for (i=0;i<m_MapSize;i++) {
		if (m_pArray[i].pKey==Key) {
			Value=m_pArray[i].pValue;
			return true;
		}
	}
	return false;
}


void AntMap::RemoveKey(void *Key)
{
	int i;

	for (i=0;i<m_MapSize;i++) {
		if (m_pArray[i].pKey==Key) {
			if (i<m_MapSize-1)
				memmove(&(m_pArray[i]),&(m_pArray[i+1]),
											sizeof(KeyInfo)*(m_MapSize-(i+1)));
			m_MapSize--;
			break;
		}
	}
}


void AntMap::RemoveValue(void *Value)
{
	int i;

	for (i=0;i<m_MapSize;i++) {
		if (m_pArray[i].pValue==Value) {
			if (i<m_MapSize-1)
				memmove(&(m_pArray[i]),&(m_pArray[i+1]),
											sizeof(KeyInfo)*(m_MapSize-(i+1)));
			m_MapSize--;
			break;
		}
	}
}


void AntMap::SetAt(void *Key,void *Value)
{
	int i;

	for (i=0;i<m_MapSize;i++) {
		if (m_pArray[i].pKey==Key) {
			m_pArray[i].pValue=Value;
			return;
		}
	}
	if (m_AllocSize==m_MapSize) {
		KeyInfo *pNewArray;

		m_AllocSize+=ALLOC_SIZE;
		pNewArray=new KeyInfo[m_AllocSize];
		memcpy(pNewArray,m_pArray,sizeof(KeyInfo)*m_MapSize);
		delete [] m_pArray;
		m_pArray=pNewArray;
	}
	m_pArray[m_MapSize].pKey=Key;
	m_pArray[m_MapSize].pValue=Value;
	m_MapSize++;
}
