/******************************************************************************
*                                                                             *
*    Settings.h                             Copyright(c) 2007-2010 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef ANT_SETTINGS_H
#define ANT_SETTINGS_H


class AntSettings
{
protected:
	unsigned int m_OpenFlags;

public:
	enum {
		OPEN_READ	=0x0001,
		OPEN_WRITE	=0x0002
	};
	AntSettings();
	virtual ~AntSettings();
	virtual void Close() {}
	virtual bool ReadInt(LPCTSTR pszName,int *pValue)=0;
	virtual bool WriteInt(LPCTSTR pszName,int Value)=0;
	virtual bool ReadString(LPCTSTR pszName,LPTSTR pszString,int MaxLength)=0;
	virtual bool WriteString(LPCTSTR pszName,LPCTSTR pszString)=0;
};

class AntRegSettings : public AntSettings
{
	HKEY m_hkey;

public:
	AntRegSettings();
	~AntRegSettings();
	bool Open(HKEY hkey,LPCTSTR pszSubKey,unsigned int Flags);
	void Close();
	bool ReadInt(LPCTSTR pszName,int *pValue);
	bool WriteInt(LPCTSTR pszName,int Value);
	bool ReadString(LPCTSTR pszName,LPTSTR pszString,int MaxLength);
	bool WriteString(LPCTSTR pszName,LPCTSTR pszString);
};

class AntIniSettings : public AntSettings
{
	TCHAR m_szFileName[MAX_PATH];
	TCHAR m_szSection[64];

public:
	AntIniSettings();
	~AntIniSettings();
	bool Open(LPCTSTR pszFileName,LPCTSTR pszSection,unsigned int Flags);
	void Close();
	bool ReadInt(LPCTSTR pszName,int *pValue);
	bool WriteInt(LPCTSTR pszName,int Value);
	bool ReadString(LPCTSTR pszName,LPTSTR pszString,int MaxLength);
	bool WriteString(LPCTSTR pszName,LPCTSTR pszString);
};


#endif	// ndef ANT_SETTINGS_H
