/******************************************************************************
*                                                                             *
*    TACManager.h                           Copyright(c) 2007-2010 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef ANT_TACMANAGER_H
#define ANT_TACMANAGER_H


#include "rmamon.h"


#define NUM_TAC_NAMES 5

#define TAC_TITLE      0
#define TAC_AUTHOR     1
#define TAC_COPYRIGHT  2
#define TAC_ABSTRACT   3
#define TAC_KEYWORDS   4


class IRMAPlayer;
class IRMAPNRegistry;
class IRMAPropWatch;


class AntTACManager : public IRMAPropWatchResponse
{
protected:
	LONG m_lRefCount;
	char *m_pTitle;
	char *m_pAuthor;
	char *m_pCopyright;
	char *m_pAbstract;
	char *m_pKeywords;
	char *m_pRegName;
	UINT32 m_uPlayerIndex;
	IRMAPropWatch *m_pPropWatch;
	IRMAPNRegistry *m_pRegistry;
	UINT32 m_uTACPropIDs[NUM_TAC_NAMES];
	virtual ~AntTACManager();
	void SetStringProp(char **ppProp,const char *pNew,UINT32 uLen);

public:
	AntTACManager();
// IUnknown
	STDMETHOD(QueryInterface)(REFIID iid, void **ppObj);
	STDMETHOD_(ULONG,AddRef)();
	STDMETHOD_(ULONG,Release)();
// IRMAPropWatchResponse
	STDMETHOD(AddedProp)(const UINT32 id,const RMAPropType propType,
													const UINT32 ulParentHash);
	STDMETHOD(ModifiedProp)(const UINT32 id,const RMAPropType propType,
													const UINT32 ulParentHash);
	STDMETHOD(DeletedProp)(const UINT32 id,const UINT32 ulParentHash);
// AntTACManager
	BOOL Init(IRMAPlayer *pPlayer);
	void Terminate();
	void Update();
	const char *GetTitle();
	const char *GetAuthor();
	const char *GetCopyright();
	const char *GetAbstract();
	const char *GetKeywords();
};


#endif	// ndef ANT_TACMANAGER_H
